#ifndef _ITDEFS_H_
#define _ITDEFS_H_

#pragma pack(1)

typedef struct tagITFILEHEADER
{
	DWORD id;			// 0x4D504D49
	CHAR songname[26];
	WORD reserved1;		// 0x1004
	WORD ordnum;
	WORD insnum;
	WORD smpnum;
	WORD patnum;
	WORD cwtv;
	WORD cmwt;
	WORD flags;
	WORD special;
	_BYTE globalvol;
	_BYTE mv;
	_BYTE speed;
	_BYTE tempo;
	_BYTE sep;
	_BYTE zero;
	WORD msglength;
	DWORD msgoffset;
	DWORD reserved2;
	_BYTE chnpan[64];
	_BYTE chnvol[64];
} ITFILEHEADER;


typedef struct tagITENVELOPE
{
	_BYTE flags;
	_BYTE num;
	_BYTE lpb;
	_BYTE lpe;
	_BYTE slb;
	_BYTE sle;
	_BYTE data[25*3];
	_BYTE reserved;
} ITENVELOPE;

// Old Impulse Instrument Format (cmwt < 0x200)
typedef struct tagITOLDINSTRUMENT
{
	DWORD id;			// IMPI = 0x49504D49
	CHAR filename[12];	// DOS file name
	_BYTE zero;
	_BYTE flags;
	_BYTE vls;
	_BYTE vle;
	_BYTE sls;
	_BYTE sle;
	WORD reserved1;
	WORD fadeout;
	_BYTE nna;
	_BYTE dnc;
	WORD trkvers;
	_BYTE nos;
	_BYTE reserved2;
	CHAR name[26];
	WORD reserved3[3];
	_BYTE keyboard[240];
	_BYTE volenv[200];
	_BYTE nodes[50];
} ITOLDINSTRUMENT;


// Impulse Instrument Format
typedef struct tagITINSTRUMENT
{
	DWORD id;
	CHAR filename[12];
	_BYTE zero;
	_BYTE nna;
	_BYTE dct;
	_BYTE dca;
	WORD fadeout;
	signed char pps;
	_BYTE ppc;
	_BYTE gbv;
	_BYTE dfp;
	_BYTE rv;
	_BYTE rp;
	WORD trkvers;
	_BYTE nos;
	_BYTE reserved1;
	CHAR name[26];
	_BYTE ifc;
	_BYTE ifr;
	_BYTE mch;
	_BYTE mpr;
	WORD mbank;
	_BYTE keyboard[240];
	ITENVELOPE volenv;
	ITENVELOPE panenv;
	ITENVELOPE pitchenv;
	_BYTE dummy[4]; // was 7, but IT v2.17 saves 554 bytes
} ITINSTRUMENT;


// IT Sample Format
typedef struct ITSAMPLESTRUCT
{
	DWORD id;		// 0x53504D49
	CHAR filename[12];
	_BYTE zero;
	_BYTE gvl;
	_BYTE flags;
	_BYTE vol;
	CHAR name[26];
	_BYTE cvt;
	_BYTE dfp;
	DWORD length;
	DWORD loopbegin;
	DWORD loopend;
	DWORD C5Speed;
	DWORD susloopbegin;
	DWORD susloopend;
	DWORD samplepointer;
	_BYTE vis;
	_BYTE vid;
	_BYTE vir;
	_BYTE vit;
} ITSAMPLESTRUCT;

#pragma pack()

extern _BYTE autovibit2xm[8];
extern _BYTE autovibxm2it[8];

#endif
